/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tdd_with_fitnesse;

import java.text.DateFormat;
import java.text.NumberFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author Selvyn
 */
public class MainUnit
{
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {
        try
        {
            String theTime1 = "9:00 AM";
            String theTime2 = "16:00 PM";
            
            SimpleDateFormat df = (SimpleDateFormat)DateFormat.getTimeInstance(DateFormat.SHORT, Locale.UK);
            
            Date d2 = df.parse(theTime2);
            Date d1 = df.parse(theTime1);
            
            long diff = d2.getTime() - d1.getTime();
            long hours = diff / (60 * 60 *1000) % 24;
            double mins = diff / (60 * 1000) % 60;
            long secs = (diff / 1000) % 60;
            
            System.out.println( hours + ":" + mins );
            
            double theHoursWorked = hours + mins / 60;
            System.out.println( theHoursWorked );
            
            Pattern pp = Pattern.compile(":|\\s");
            Matcher mm = pp.matcher(theTime1);
            String items[] = pp.split(theTime1);
            
            for( int x=0; x < items.length; x++ )
                System.out.println( items[x]);
            
            mm = pp.matcher(theTime2);
            items = pp.split(theTime2);
            
            for( int x=0; x < items.length; x++ )
                System.out.println( items[x]);

            String theTime3 = "9:00 AM";
            String theTime4 = "4:00 PM";

            System.out.println( "==========make canonical==============");
            TimeFormatter tf = TimeFormatter.getInstance();
            String canString = tf.makeCanonicalTimeFormat("23:00am");
            System.out.println( canString );
            canString = tf.makeCanonicalTimeFormat(theTime3);
            System.out.println( canString );
            
            System.out.println( "==========format==============");
            System.out.println( tf.format( theTime3 ) );
            System.out.println( tf.format( theTime4 ) );
            
            NumberFormat nf = NumberFormat.getIntegerInstance();
            nf.setMinimumIntegerDigits(2);
            System.out.println( nf.format(11));
            
            TimeSheet ts = new TimeSheet();
            ts.setCheckInTime("13:05 AM");
            ts.setCheckOutTime("4:30pm");
            ts.execute();
            System.out.println( ts.getCheckInTimeNormalized() + "/" + ts.getCheckOutTimeNormalized() );
            System.out.println( ts.HoursWorked() );
            System.out.println( ts.Pay() );
            
        } catch (ParseException ex)
        {
            Logger.getLogger(TimeSheet.class.getName()).log(Level.SEVERE, null, ex);
        } catch (BadlyFormedTime ex)
        {
            Logger.getLogger(TimeSheet.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
