/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tdd_with_fitnesse;

import java.text.DateFormat;
import java.text.NumberFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author Selvyn
 */
public class TimeSheet
{
    private String itsCheckInTime = "";
    private String itsCheckOutTime = "";
    private String itsCheckInTimeNormalized = "NIL";
    private String itsCheckOutTimeNormalized = "NIL";
    private double rate = 0.0;
    private double itsHoursWorked = 0.0;
    private final TimeFormatter timefx = new TimeFormatter();
    private Calculator  itsWorkCalculator = new WorkCalculator();

    public  void    setCalculator( Calculator calc )
    {
        itsWorkCalculator = calc;
    }
    public String getCheckInTimeNormalized()
    {
        return itsCheckInTimeNormalized;
    }

    public String getCheckOutTimeNormalized()
    {
        return itsCheckOutTimeNormalized;
    }
    
    public void setCheckInTime(String checkintime)
    {
        this.itsCheckInTime = checkintime;
        try
        {
            itsCheckInTimeNormalized = timefx.format(itsCheckInTime);
        } 
        catch (BadlyFormedTime ex)
        {
            itsCheckInTimeNormalized = timefx.getTokens()[0];
        }
    }

    public void setCheckOutTime(String checkouttime)
    {
        this.itsCheckOutTime = checkouttime;
        try
        {
            itsCheckOutTimeNormalized = timefx.format(itsCheckOutTime);
        } 
        catch (BadlyFormedTime ex)
        {
            itsCheckOutTimeNormalized = timefx.getTokens()[0];
        }
    }

    public void setHourlyRate(String rate)
    {
        this.rate = Double.parseDouble(rate);
    }
    
    public  String  CheckInTimeNormalized()
    {
        return itsCheckInTimeNormalized;
    }

    public  String  CheckOutTimeNormalized()
    {
        return itsCheckOutTimeNormalized;
    }
    
    public  String  Pay2() throws Exception
    {
        throw new Exception();
    }

    public String Pay()
    {
        if( itsHoursWorked < 0 )
            return "0.00";
        else
        {
            NumberFormat nf = NumberFormat.getNumberInstance();
            nf.setMaximumFractionDigits(2);
            nf.setMinimumFractionDigits(2);

            return nf.format(rate * itsHoursWorked);
        }
    }

    public  String  HoursWorked()
    {
        if( itsHoursWorked < 0 )
            return "0.00";
        else
        {
            NumberFormat nf = NumberFormat.getNumberInstance();
            nf.setMaximumFractionDigits(2);
            nf.setMinimumFractionDigits(2);

            String str = nf.format(itsHoursWorked);
            return nf.format(itsHoursWorked);
        }
    }
    //returns the number of hours worked
    public double calculateHoursWorked()
    {
        itsHoursWorked = itsWorkCalculator.calculateHoursWorked(itsCheckInTimeNormalized, itsCheckOutTimeNormalized);
        
        return itsHoursWorked;
    }
    
    public  void    execute()
    {
        calculateHoursWorked();
    }

 
}
