/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tdd_with_fitnesse;

import static org.hamcrest.Matchers.equalTo;
import static org.hamcrest.Matchers.is;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Selvyn
 */
public class WorkCalculatorTest
{
    @Test
    public void testSameTimes()
    {
        WorkCalculator wc = new WorkCalculator();
        String inTime = "13:13";
        String outTime = "13:13";
        double expectedResult = 0.0;

        double hoursWorked = wc.calculateHoursWorked(inTime, outTime);

        assertThat(hoursWorked, is(equalTo(expectedResult )));
    }

    @Test
    public void testOutTimeGreaterThanInTime()
    {
        WorkCalculator wc = new WorkCalculator();
        String inTime = "09:00";
        String outTime = "17:30";
        double expectedResult = 8.5;

        double hoursWorked = wc.calculateHoursWorked(inTime, outTime);

        assertThat(hoursWorked, is(equalTo(expectedResult)));
    }

}
